import { Children, cloneElement } from 'react';
export function isFn(v) {
  return typeof v === 'function';
}
export function isStr(v) {
  return typeof v === 'string';
}
export function cloneItems(children, props) {
  return Children.map(
  // remove null item
  Children.toArray(children).filter(Boolean), function (item) {
    return /*#__PURE__*/cloneElement(item, props);
  });
}
export function getMousePosition(e) {
  var pos = {
    x: e.clientX,
    y: e.clientY
  };
  var touch = e.changedTouches;
  if (touch) {
    pos.x = touch[0].clientX;
    pos.y = touch[0].clientY;
  }
  if (!pos.x || pos.x < 0) pos.x = 0;
  if (!pos.y || pos.y < 0) pos.y = 0;
  return pos;
}
export function getPredicateValue(predicate, payload) {
  return isFn(predicate) ? predicate(payload) : predicate;
}