/// <reference types="react" />
import { MenuId, TriggerEvent } from '../types';
export interface ContextMenu {
    show: <TProps>(params: ShowContextMenuParams<TProps>) => void;
    hideAll: () => void;
}
export interface ShowContextMenuParams<TProps = unknown> {
    id: MenuId;
    event: TriggerEvent;
    props?: TProps;
    position?: {
        x: number;
        y: number;
    } | null;
    children?: React.ReactNode;
}
declare const contextMenu: ContextMenu;
export { contextMenu };
