function createEventManager() {
  var eventList = new Map();
  return {
    on: function on(event, handler) {
      eventList.has(event) ? eventList.get(event).add(handler) : eventList.set(event, new Set([handler]));
      return this;
    },
    off: function off(event, handler) {
      eventList.has(event) && eventList.get(event)["delete"](handler);
      return this;
    },
    emit: function emit(event, args) {
      eventList.has(event) && eventList.get(event).forEach(function (handler) {
        handler(args);
      });
      return this;
    }
  };
}
export var eventManager = createEventManager();