"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Submenu = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ItemTrackerProvider = require("./ItemTrackerProvider");
var _hooks = require("../hooks");
var _constants = require("../constants");
var _utils = require("./utils");
var _Arrow = require("./Arrow");
var _RightSlot = require("./RightSlot");
var _excluded = ["arrow", "children", "disabled", "hidden", "label", "className", "triggerEvent", "propsFromTrigger", "style"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var Submenu = exports.Submenu = function Submenu(_ref) {
  var _cx;
  var arrow = _ref.arrow,
    children = _ref.children,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$hidden = _ref.hidden,
    hidden = _ref$hidden === void 0 ? false : _ref$hidden,
    label = _ref.label,
    className = _ref.className,
    triggerEvent = _ref.triggerEvent,
    propsFromTrigger = _ref.propsFromTrigger,
    style = _ref.style,
    rest = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var parentItemTracker = (0, _ItemTrackerProvider.useItemTrackerContext)();
  var itemTracker = (0, _hooks.useItemTracker)();
  var submenuNode = (0, _react.useRef)(null);
  var handlerParams = {
    triggerEvent: triggerEvent,
    props: propsFromTrigger
  };
  var isDisabled = (0, _utils.getPredicateValue)(disabled, handlerParams);
  var isHidden = (0, _utils.getPredicateValue)(hidden, handlerParams);
  function setPosition() {
    var node = submenuNode.current;
    if (node) {
      var bottom = _constants.CssClass.submenu + "-bottom";
      var right = _constants.CssClass.submenu + "-right";

      // reset to default position before computing position
      node.classList.remove(bottom, right);
      var rect = node.getBoundingClientRect();
      if (rect.right > window.innerWidth) node.classList.add(right);
      if (rect.bottom > window.innerHeight) node.classList.add(bottom);
    }
  }
  function trackRef(node) {
    if (node && !isDisabled) parentItemTracker.set(node, {
      node: node,
      isSubmenu: true,
      submenuRefTracker: itemTracker,
      setSubmenuPosition: setPosition
    });
  }
  if (isHidden) return null;
  var cssClasses = (0, _classnames["default"])(_constants.CssClass.item, className, (_cx = {}, _cx["" + _constants.CssClass.itemDisabled] = isDisabled, _cx));
  return /*#__PURE__*/_react["default"].createElement(_ItemTrackerProvider.ItemTrackerProvider, {
    value: itemTracker
  }, /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, rest, {
    className: cssClasses,
    ref: trackRef,
    tabIndex: -1,
    role: "menuitem",
    "aria-haspopup": true,
    "aria-disabled": isDisabled,
    onMouseEnter: setPosition,
    onTouchStart: setPosition
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _constants.CssClass.itemContent,
    onClick: function onClick(e) {
      return e.stopPropagation();
    }
  }, label, /*#__PURE__*/_react["default"].createElement(_RightSlot.RightSlot, null, arrow || /*#__PURE__*/_react["default"].createElement(_Arrow.Arrow, null))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _constants.CssClass.menu + " " + _constants.CssClass.submenu,
    ref: submenuNode,
    style: style
  }, (0, _utils.cloneItems)(children, {
    propsFromTrigger: propsFromTrigger,
    // @ts-ignore: injected by the parent
    triggerEvent: triggerEvent
  }))));
};