"use strict";

exports.__esModule = true;
exports.cloneItems = cloneItems;
exports.getMousePosition = getMousePosition;
exports.getPredicateValue = getPredicateValue;
exports.isFn = isFn;
exports.isStr = isStr;
var _react = require("react");
function isFn(v) {
  return typeof v === 'function';
}
function isStr(v) {
  return typeof v === 'string';
}
function cloneItems(children, props) {
  return _react.Children.map(
  // remove null item
  _react.Children.toArray(children).filter(Boolean), function (item) {
    return /*#__PURE__*/(0, _react.cloneElement)(item, props);
  });
}
function getMousePosition(e) {
  var pos = {
    x: e.clientX,
    y: e.clientY
  };
  var touch = e.changedTouches;
  if (touch) {
    pos.x = touch[0].clientX;
    pos.y = touch[0].clientY;
  }
  if (!pos.x || pos.x < 0) pos.x = 0;
  if (!pos.y || pos.y < 0) pos.y = 0;
  return pos;
}
function getPredicateValue(predicate, payload) {
  return isFn(predicate) ? predicate(payload) : predicate;
}