"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SVGIcon = SVGIcon;
exports.SizePresets = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = _interopRequireDefault(require("react"));
var _excluded = ["fill", "size", "viewBox", "style", "children"];
var SizePresets = exports.SizePresets = {
  xsmall: 8,
  small: 14,
  medium: 16,
  large: 20,
  xlarge: 30
};
function SVGIcon(_ref) {
  var fill = _ref.fill,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'medium' : _ref$size,
    viewBox = _ref.viewBox,
    style = _ref.style,
    children = _ref.children,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  // eslint-disable-next-line no-prototype-builtins
  if (SizePresets.hasOwnProperty(size)) {
    size = SizePresets[size];
  }
  return /*#__PURE__*/_react["default"].createElement("svg", (0, _extends2["default"])({
    fill: "currentColor",
    preserveAspectRatio: "xMidYMid meet",
    width: size,
    height: size,
    viewBox: viewBox
  }, props, {
    style: (0, _extends2["default"])({
      color: fill
    }, style)
  }), children);
}